# Changelog

## 2024-11-05 - 1.7.6 - fix(tspublish)
Fix the logging of the number of found publish modules

- Corrected the way the number of publish modules is logged by using Object.keys(publishModules).length instead of publishModules.length.

## 2024-11-05 - 1.7.5 - fix(core)
Fix issue with tspublish.json name validation in TsPublish class

- Resolved incorrect JSON parsing and validation for 'name' property in tspublish.json in the TsPublish.publish method.
- Removed redundant JSON parse from plugin.smartfile.fs.toStringSync in publish method.

## 2024-11-05 - 1.7.4 - fix(classes.tspublish)
Refactor getModuleSubDirs method to streamline name validation for publish modules

- Moved the check for the presence of the 'name' field in tspublish.json from getModuleSubDirs to the publish method.
- Added log warning and continue flow if 'name' is not found during the publish process.

## 2024-11-05 - 1.7.3 - fix(TsPublish)
Add validation for tspublish.json name field

- Ensure that the tspublish.json file contains a valid name field before processing.
- Log a warning message if the name is not found in tspublish.json.

## 2024-11-05 - 1.7.2 - fix(project)
Fixed minor formatting issues and improved code consistency.

- Added missing semicolons for consistency
- Improved indentation in various files for better readability
- Corrected usage of newlines and whitespace across the codebase

## 2024-11-05 - 1.7.1 - fix(core)
Implement error handling for missing publish module directories

- Improved logging for package publish steps
- Enhanced CLI feedback messages during the publishing process
- Restructured package.json to ensure proper dependencies are published

## 2024-11-05 - 1.7.0 - feat(core)
Enhanced tspublish with ordered compilation and updated dependencies

- Added 'order' property to ITsPublishJson interface to ensure project compilation order.
- Updated development dependencies: @git.zone/tsbuild, @git.zone/tsbundle, @git.zone/tsrun, and @types/node.

## 2024-10-28 - 1.6.0 - feat(classes.publishmodule)
Added copying of readme and license files to publish directory

- Enhanced the createPublishModuleDir method in PublishModule class to copy the 'readme.md' and 'license' files to the publish directory.

## 2024-10-28 - 1.5.5 - fix(core)
Handled non-existent package in publish module to avoid errors

- Added error handling in TsPublish for packages not yet existing in the registry.

## 2024-10-28 - 1.5.4 - fix(core)
Fix issues with path keys in tsconfig and logger setup in logging.ts.

- Corrected the iteration over paths in the createTsconfigJson method of PublishModule.
- Fixed logger setup by ensuring console is enabled in logging.ts.

## 2024-10-28 - 1.5.3 - fix(core)
Fix incorrect logging and directory preparation

- Corrected logging to accurately report the number of detected publish modules.
- Ensured the publish directory is emptied before creating package.json.

## 2024-10-28 - 1.5.2 - fix(core)
Add logging for found publish modules

- Added console logging to display the count and list of discovered publish modules during the publish process.
- Included a startup log message indicating the beginning of the tspublish process.

## 2024-10-28 - 1.5.1 - fix(core)
Fixes handling of undefined paths in tsconfig generation.

- Added a null check for `paths` in the original tsconfig before modifying it.
- Enhanced testing by adding a test case for creating a TsPublish instance.

## 2024-10-28 - 1.5.0 - feat(classes.publishmodule)
Add method to create and write tsconfig.json during publish module setup

- Introduced createTsconfigJson method in PublishModule class to generate a tsconfig.json for each publishable module.
- Modified createPublishModuleDir method to include writing of tsconfig.json file.

## 2024-10-26 - 1.4.0 - feat(core)
Refactor directory reading and module discovery for publishing process

- Renamed 'readDirectory' method to 'getModuleSubDirs' for clarity in describing function purpose.
- Enhanced 'getModuleSubDirs' to return module information including parsed 'tspublish.json' data for each module.
- Introduced new 'interfaces' directory to define TypeScript interfaces like 'ITsPublishJson'.

## 2024-10-23 - 1.3.3 - fix(core)
Fix logging mechanism on existing package version check

- Changed the error handling mechanism when a package with the same version already exists to use logger and process exit instead of throwing an error.

## 2024-10-23 - 1.3.2 - fix(core)
Corrected file patterns in dynamically created package.json files.

- Fixed incorrect file pattern from 'ts_web/**/*' to 'ts_*/**/*' in package.json creation process to include all subdirectories starting with 'ts'.

## 2024-10-23 - 1.3.1 - fix(classes.publishmodule)
Fix template string in createPackageJson method for export path

- Corrected the syntax for template string in the exports path of created package.json

## 2024-10-21 - 1.3.0 - feat(core)
Add support for multiple registries in the publish process

- Updated the PublishModule class to handle multiple registries for publishing.
- Refactored the handling of tspublish.json by incorporating it into the PublishModule options.
- Implemented logic to parse registry access level and apply it during publication.

## 2024-10-21 - 1.2.4 - fix(publishmodule)
Fix syntax errors and improve formatting in classes.publishmodule.ts

- Fixed missing semicolons in multiple locations for improved syntax correctness.
- Improved the formatting for better code readability.
- Added --no-git-checks flag to the pnpm publish command.

## 2024-10-21 - 1.2.3 - fix(logs)
Improve logging mechanism with structured logs for publish process

- Enhanced log messages to provide more clarity during module publishing.
- Ensured logging captures steps of publish and init process in TsPublish and PublishModule classes respectively.

## 2024-10-21 - 1.2.3 - fix(classes.publishmodule)
Add missing 'type: module' to dynamically generated package.json

- Ensure that the 'type: module' field is included in each dynamically generated package.json file for consistent module handling.

## 2024-10-21 - 1.2.3 - fix(classes.publishmodule)
Add missing 'type: module' to dynamically generated package.json

- Ensure that the 'type: module' field is included in each dynamically generated package.json file for consistent module handling.

## 2024-10-21 - 1.2.2 - fix(publishmodule)
Fix bug in package.json creation for publish module

- Fixed an issue where `package.json` was not being written to the publish module directory.

## 2024-10-21 - 1.2.1 - fix(package.json)
Ensure bin field is properly restructured

- Fixed the structure of the package.json to ensure the bin field is accurately set.

## 2024-10-21 - 1.2.0 - feat(core)
Enhance package publication workflow with dependency handling and CLI improvements.

- Updated package description and keywords in package.json and npmextra.json.
- Integrated dependency extraction from root package.json into sub-package tspublish.json during initialization.
- Added build and publish script executions for each submodule.
- Improved CLI documentation and usage guidance in readme.md.

## 2024-10-21 - 1.1.0 - feat(core)
Add runCli function to execute TsPublish process

- Introduced runCli function to start publish workflow using TsPublish class.
- Enhanced the process to read directory and create publish module directories.
- Improved logging for better tracking of found publish modules.

## 2024-10-21 - 1.0.1 - Initial Release
Initial release of the project.

- First version of the codebase
